CREATE OR REPLACE FUNCTION ARQUIVO_DCTF_R31 (
   P_CDLIVROMAG   IN LIVROMAGNETICO.CDLIVROMAG%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_SITUACAO     IN NOTAFISCAL.IDSTATUS%TYPE,
   V_IRPJ       VARCHAR2,
   V_IRRF       VARCHAR2,
   V_IPI        VARCHAR2,
   V_IOF        VARCHAR2,
   V_CSLL       VARCHAR2,
   V_PIS        VARCHAR2,
   V_COFINS     VARCHAR2,
   V_CPMF       VARCHAR2,
   V_CIDE       VARCHAR2,
   V_RET        VARCHAR2,
   V_CSRF       VARCHAR2,
   V_COSIRF     VARCHAR2,
   V_CPSSS      VARCHAR2) RETURN NUMBER
AS
   V_CONTREGAR31   NUMBER;
BEGIN
   V_CONTREGAR31 := 0;
   FOR C_REG_31_IRPJ IN (SELECT (RPAD('R31',3,' '))                                                                           ||/*REGISTRO*/
                                LPAD(REPLACE(REPLACE(REPLACE(REPLACE(NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)       ||/*CNPJ*/
                                TO_CHAR(P_DTINICIAL,'YYYYMM')                                                                 ||/*ANO E MES DE OCORRENCIA*/
                                P_SITUACAO                                                                                    ||/*SITUACAO*/
                                DECODE(P_SITUACAO,'0',RPAD('0',8,'0'), TO_CHAR(TO_DATE(P_DTINICIAL),'YYYYMMDD'))              ||/*DATA DO EVENTO*/
                                V_IRPJ                                                                                        ||/*TRIBUTO*/
                                NVL(CDRECEITACONTR||CDVARIACAO,'000000')                                                      ||/*CODIGO DA RECEITA/ VARIACAO*/
                                IDPERIODICREC                                                                                 ||/*PERIODICIDADE*/
                                TO_CHAR(DTFIMPERIODO,'YYYY')                                                                  ||/*ANO DE APURACAO*/
                                DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'03','01',DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'06','02',DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'09','03','04')))||/*TRIMESTRE*/
                                '00'                                                                                          ||/*RESERVADO*/
                                RPAD('0',6,'0')                                                                               ||/*RESERVADO*/
                                RPAD('0',14,'0')                                                                              ||/*RESERVADO*/
                                CDOBRIGAGUIA                                                                                  ||/*N DA QUOTA*/
                                TO_CHAR(P_DTFINAL,'DDMMYYYY')                                                                 ||/*PERIODO DE APURACAO*/
                                LPAD(REPLACE(REPLACE(REPLACE(REPLACE(NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)       ||/*CNPJ DA DARF*/
                                CDRECEITAGUIA                                                                                 ||/*CODIGO DA RECEITA DO DARF*/
                                TO_CHAR(DTVENCGUIACOMPL,'DDMMYYYY')                                                           ||/*VENCIMENTO DA DARF*/
                                RPAD(' ',17,' ')                                                                              ||/*N DE REFERENCIA*/
                                LPAD(LTRIM(REPLACE(TO_CHAR(VRDEBITO,'000000000000.00'),'.')),'14','0')                        ||/*VALOR DO PRINCIPAL*/
                                LPAD(LTRIM(REPLACE(TO_CHAR(NVL(VRMULTAGUIACOMP,0),'000000000000.00'),'.')),'14','0')          ||/*VALOR DA MULTA*/
                                LPAD(LTRIM(REPLACE(TO_CHAR(NVL(VRJUROSGUIACOMP,0),'000000000000.00'),'.')),'14','0')          ||/*VALOR DO JUROS*/
                                LPAD(LTRIM(REPLACE(TO_CHAR(VRDEBITO,'000000000000.00'),'.')),'14','0')                        ||/*VALOR PAGO DA QUOTA*/
                                RPAD(' ',10,'0')  AS  REG_31_IRPJ,
                                NVL(IDGUIAIMPR,'N') AS IDGUIAIMPR
                           FROM (SELECT SUM(ROUND(NVL(G.VRTOTALGUIACOMP,G.VRRECEITAGUIA),2)) AS VRDEBITO, E.NRINSJUREMPR,
                                        CDRECEITACONTR,G.CDRECEITAGUIA,G.DTVENCGUIACOMPL,G.VRRECEITAGUIA,G.VRMULTAGUIACOMP,
                                        G.VRJUROSGUIACOMP, IDGUIAIMPR, CDVARIACAO,IDPERIODICREC, CDOBRIGAGUIA, MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO
                                   FROM EMPRESA E, MAPAAPURAC MP , GUIACOMPLMAPA G
                                  WHERE E.CDEMPRESA     = P_CDEMPRESA
                                    AND E.CDEMPRESA     = MP.CDEMPRESA
                                    AND MP.CDIMPOSTO    = '25'
                                    AND TO_CHAR(TO_DATE(P_DTFINAL),'MM') IN ('03','06','09','12')
                                    AND MP.DTINIPERIODO = ADD_MONTHS(P_DTINICIAL,-5)
                                    AND MP.DTFIMPERIODO = ADD_MONTHS(P_DTFINAL,-3)
                                    AND MP.NRSEQUMAPAPU = G.NRSEQUMAPAPU
                                  GROUP BY E.NRINSJUREMPR,CDRECEITACONTR,G.CDRECEITAGUIA,G.DTVENCGUIACOMPL,G.VRRECEITAGUIA,
                                        CDOBRIGAGUIA, G.VRMULTAGUIACOMP,G.VRJUROSGUIACOMP, NVL(G.VRTOTALGUIACOMP,G.VRRECEITAGUIA),
                                        IDGUIAIMPR, CDVARIACAO,IDPERIODICREC))LOOP
      IF C_REG_31_IRPJ.IDGUIAIMPR = 'S' THEN
         V_CONTREGAR31 := NVL(V_CONTREGAR31,0)+1;
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('04'||LPAD(RTRIM(V_CONTREGAR31), 8, '0'), C_REG_31_IRPJ.REG_31_IRPJ, P_NRSEQARQMAG);
      END IF;
   END LOOP ;

   FOR C_REG_31_CSLL IN (SELECT (RPAD('R31',3,' '))                                                                           ||/*REGISTRO*/
                                LPAD(REPLACE(REPLACE(REPLACE(REPLACE(NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)       ||/*CNPJ*/
                                TO_CHAR(P_DTINICIAL,'YYYYMM')                                                                 ||/*ANO E MES DE OCORRENCIA*/
                                P_SITUACAO                                                                                    ||/*SITUACAO*/
                                DECODE(P_SITUACAO,'0',RPAD('0',8,'0'), TO_CHAR(TO_DATE(P_DTINICIAL),'YYYYMMDD'))              ||/*DATA DO EVENTO*/
                                V_CSLL                                                                                        ||/*TRIBUTO*/
                                NVL(CDRECEITACONTR||CDVARIACAO,'000000')                                                      ||/*CODIGO DA RECEITA/ VARIACAO*/
                                IDPERIODICREC                                                                                 ||/*PERIODICIDADE*/
                                TO_CHAR(DTFIMPERIODO,'YYYY')                                                                  ||/*ANO DE APURACAO*/
                                DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'03','01',DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'06','02',DECODE(TO_CHAR(DTFIMPERIODO,'MM'),'09','03','04')))||/*TRIMESTRE*/
                                '00'                                                                                          ||/*RESERVADO*/
                                RPAD('0',6,'0')                                                                               ||/*RESERVADO*/
                                RPAD('0',14,'0')                                                                              ||/*RESERVADO*/
                                CDOBRIGAGUIA                                                                                  ||/*N DA QUOTA*/
                                TO_CHAR(P_DTFINAL,'DDMMYYYY')                                                                 ||/*PERIODO DE APURACAO*/
                                LPAD(REPLACE(REPLACE(REPLACE(REPLACE(NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)       ||/*CNPJ DA DARF*/
                                CDRECEITAGUIA                                                                                 ||/*CODIGO DA RECEITA DO DARF*/
                                TO_CHAR(DTVENCGUIACOMPL,'DDMMYYYY')                                                           ||/*VENCIMENTO DA DARF*/
                                RPAD(' ',17,' ')                                                                              ||/*N DE REFERENCIA*/
                                LPAD(LTRIM(REPLACE(TO_CHAR(VRDEBITO,'000000000000.00'),'.')),'14','0')                        ||/*VALOR DO PRINCIPAL*/
                                LPAD(LTRIM(REPLACE(TO_CHAR(NVL(VRMULTAGUIACOMP,0),'000000000000.00'),'.')),'14','0')          ||/*VALOR DA MULTA*/
                                LPAD(LTRIM(REPLACE(TO_CHAR(NVL(VRJUROSGUIACOMP,0),'000000000000.00'),'.')),'14','0')          ||/*VALOR DO JUROS*/
                                LPAD(LTRIM(REPLACE(TO_CHAR(VRDEBITO,'000000000000.00'),'.')),'14','0')                        ||/*VALOR PAGO DA QUOTA*/
                                RPAD(' ',10,'0')  AS  REG_31_CSLL,
                                NVL(IDGUIAIMPR,'N') AS IDGUIAIMPR
                           FROM (SELECT SUM(ROUND(NVL(G.VRTOTALGUIACOMP,G.VRRECEITAGUIA),2)) AS VRDEBITO, E.NRINSJUREMPR,
                                        CDRECEITACONTR,G.CDRECEITAGUIA,G.DTVENCGUIACOMPL,G.VRRECEITAGUIA,G.VRMULTAGUIACOMP,
                                        G.VRJUROSGUIACOMP, IDGUIAIMPR, CDVARIACAO,IDPERIODICREC, CDOBRIGAGUIA, MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO
                                   FROM EMPRESA E, MAPAAPURAC MP , GUIACOMPLMAPA G
                                  WHERE E.CDEMPRESA     = P_CDEMPRESA
                                    AND E.CDEMPRESA     = MP.CDEMPRESA
                                    AND MP.CDIMPOSTO    = '70'
                                    AND TO_CHAR(TO_DATE(P_DTFINAL),'MM') IN ('03','06','09','12')
                                    AND MP.DTINIPERIODO = ADD_MONTHS(P_DTINICIAL,-5)
                                    AND MP.DTFIMPERIODO = ADD_MONTHS(P_DTFINAL,-3)
                                    AND MP.NRSEQUMAPAPU = G.NRSEQUMAPAPU
                                   GROUP BY E.NRINSJUREMPR,CDRECEITACONTR,G.CDRECEITAGUIA,G.DTVENCGUIACOMPL,G.VRRECEITAGUIA,
                                       CDOBRIGAGUIA,G.VRMULTAGUIACOMP,G.VRJUROSGUIACOMP, NVL(G.VRTOTALGUIACOMP,G.VRRECEITAGUIA),
                                       IDGUIAIMPR, CDVARIACAO,IDPERIODICREC))LOOP
      IF C_REG_31_CSLL.IDGUIAIMPR = 'S' THEN
         V_CONTREGAR31 := NVL(V_CONTREGAR31,0)+1;
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('07'||LPAD(RTRIM(V_CONTREGAR31), 8, '0'), C_REG_31_CSLL.REG_31_CSLL, P_NRSEQARQMAG);
      END IF;
   END LOOP ;
   RETURN V_CONTREGAR31;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DCTF_R31','5.03.034'); END;
/