IF EXISTS(SELECT *
            FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'STATUS_LOTECTB_BAIXAPAGA' 
             AND TYPE   = 'TR'
             AND U.UID  = O.UID 
             AND U.NAME = USER)
   DROP TRIGGER STATUS_LOTECTB_BAIXAPAGA;
GO

CREATE TRIGGER STATUS_LOTECTB_BAIXAPAGA ON BAIXAPAGA
FOR DELETE
AS
DECLARE @V_CDLOTE           VARCHAR(20);
DECLARE @V_NRLANCLOTE       VARCHAR(06);
DECLARE @V_DTINICCTBL       DATETIME;
DECLARE @V_DTFINACCTBL      DATETIME;
DECLARE @OLD_CDEMPRESA      VARCHAR(2);
DECLARE @OLD_DTBAIXAPAG     DATETIME;
DECLARE @OLD_CDFILIAL       VARCHAR(4);
DECLARE @OLD_NRBAIXAPAG     VARCHAR(10);
DECLARE @V_IDTPGERACAOCONT  VARCHAR(01);
DECLARE @V_INSERTED         INT;
DECLARE @V_DELETED          INT;
DECLARE @NEW_IDSTATUSCTBPAG VARCHAR(01);
DECLARE @OLD_IDSTATUSCTBPAG VARCHAR(01);
BEGIN
   SELECT @V_IDTPGERACAOCONT = IDTPGERACAOCONT FROM PARAMCTBL;

   IF @V_IDTPGERACAOCONT <> 'O' BEGIN

      DECLARE C_BAIXAPAGA CURSOR FOR
         SELECT CDEMPRESA, DTBAIXAPAG, CDFILIAL, NRBAIXAPAG, IDSTATUSCTBPAG
           FROM DELETED;
      OPEN C_BAIXAPAGA;

      FETCH NEXT FROM C_BAIXAPAGA INTO @OLD_CDEMPRESA, @OLD_DTBAIXAPAG, @OLD_CDFILIAL, @OLD_NRBAIXAPAG, @OLD_IDSTATUSCTBPAG;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT @V_DTINICCTBL = DTINICCTBL, @V_DTFINACCTBL = DTFINACCTBL
           FROM CONTOPECTBL
          WHERE CDEMPRESA = @OLD_CDEMPRESA;

         SELECT @V_INSERTED = COUNT(*) FROM INSERTED;

         SELECT @V_DELETED = COUNT(*) FROM DELETED;

            IF ((@V_DELETED <> 0) AND (@V_INSERTED = 0)) BEGIN
               IF ((@OLD_DTBAIXAPAG >= @V_DTINICCTBL) AND (@OLD_DTBAIXAPAG <= @V_DTFINACCTBL)) BEGIN
                  DECLARE C_RELACBPAGLANLOT CURSOR FOR
                     SELECT MAX(CDLOTE) AS CDLOTE, MAX(NRLANCLOTE) AS NRLANCLOTE
                       FROM RELACBPAGLANLOT
                      WHERE CDFILIAL   = @OLD_CDFILIAL
                        AND NRBAIXAPAG = @OLD_NRBAIXAPAG;
                  OPEN C_RELACBPAGLANLOT;

                  FETCH NEXT FROM C_RELACBPAGLANLOT INTO @V_CDLOTE, @V_NRLANCLOTE;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     EXEC REVERTE_LOTE @OLD_CDEMPRESA, @V_CDLOTE;

                      /* DELETA O LANCLOTE DA BAIXA*/

                     DELETE FROM RELACBPAGLANLOT
                      WHERE CDEMPRESA  = @OLD_CDEMPRESA
                        AND NRLANCLOTE = @V_NRLANCLOTE
                        AND CDFILIAL   = @OLD_CDFILIAL
                        AND NRBAIXAPAG = @OLD_NRBAIXAPAG;

                     DELETE FROM LANCLOTE
                      WHERE CDEMPRESA  = @OLD_CDEMPRESA
                        AND CDLOTE     = @V_CDLOTE
                        AND NRLANCLOTE = @V_NRLANCLOTE;

                     FETCH NEXT FROM C_RELACBPAGLANLOT INTO @V_CDLOTE, @V_NRLANCLOTE;
                  END;
                  CLOSE C_RELACBPAGLANLOT;
                  DEALLOCATE C_RELACBPAGLANLOT;
               END
               ELSE BEGIN
                  RAISERROR('Excluso no permitida, data da baixa a pagar fora do perodo de integrao financeiro.', 16, 1);
               END;
            END;
         FETCH NEXT FROM C_BAIXAPAGA INTO @OLD_CDEMPRESA, @OLD_DTBAIXAPAG, @OLD_CDFILIAL, @OLD_NRBAIXAPAG, @OLD_IDSTATUSCTBPAG;
      END;
      CLOSE C_BAIXAPAGA;
      DEALLOCATE C_BAIXAPAGA;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'STATUS_LOTECTB_BAIXAPAGA','5.09.000';
GO
